// -------------------------------------------------------------
// GPU particle
// 
// Copyright (c) 2002-2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;			// ϊs
float4	 vVector;		// ʒuƂ̓KȃxNg

texture DecaleMap;
sampler DecaleSamp = sampler_state
{
    Texture = <DecaleMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
texture ParticleMap;
sampler ParticleSamp = sampler_state
{
    Texture = <ParticleMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

// -------------------------------------------------------------
// _VF[_o̓f[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Color	: COLOR0;
};
// -------------------------------------------------------------
struct INIT_VS_OUTPUT
{
    float4 Pos		: POSITION;
};
// -------------------------------------------------------------
struct PARTICLE_VS_OUTPUT
{
	float4 Pos		: POSITION;
	float2 x		: TEXCOORD0;
	float2 dx		: TEXCOORD1;
};
// -------------------------------------------------------------
struct REFLECT_VS_OUTPUT
{
	float4 Pos		: POSITION;
	float2 x		: TEXCOORD0;
	float2 v		: TEXCOORD1;
};

// -------------------------------------------------------------
// p[eBN̕`
// 
//  c0 - c3 - Wϊ
//  c12     - (0.0, 0.5, 1.0, 2.0)
// -------------------------------------------------------------
VertexShader DisplacementVS = asm
{
    vs_1_1
    
    dcl_position0 v0
    dcl_normal0   v1
    dcl_texcoord0 v2
    dcl_sample0   v3
    
    def c12, 0.0f ,0.5f, 1.0f, 2.0f
    
    mad r0, v3, c12.w, -c12.z
    add r0, v0, r0      // fBXv[Xg̗ʂ𒸓_ɒǉ
    mov r0.w, v0.w      // w=1
    m4x4 oPos, r0, c0   // XN[W
    
    mov oT0, v2         // eNX`W
};
// -------------------------------------------------------------
PIXELSHADER DisplacementPS = asm
{
    ps.1.1
	
	tex t0
	
	mov r0, t0
};
// -------------------------------------------------------------
// p[eBN}bv̏
// -------------------------------------------------------------
INIT_VS_OUTPUT InitVS (
      float4 Pos    : POSITION
){
    INIT_VS_OUTPUT Out = (INIT_VS_OUTPUT)0;
	
    Out.Pos = Pos;
	
    return Out;
}
// -------------------------------------------------------------
float4 InitPS(INIT_VS_OUTPUT In) : COLOR
{   
    return vVector;
}


// -------------------------------------------------------------
// p[eBN}bv̍XV
// -------------------------------------------------------------
float4 ParticlePS(PARTICLE_VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	Color  =  tex2D( ParticleSamp, In.x )
			+ tex2D( ParticleSamp, In.dx )
			- 0.502;// 0.5𒆉ɂB0.002́HHH
    return Color;
}


// -------------------------------------------------------------
// ˕Ԃ(x)
// -------------------------------------------------------------
float4 ReflectVPS ( REFLECT_VS_OUTPUT In ) : COLOR0
{
	float4 x = 2.0f*tex2D( ParticleSamp, In.x )-1.0f;
	float4 v = 2.0f*tex2D( ParticleSamp, In.v )-1.0f;
	
	if(x.x<-1.0f || +1.0f<x.x) v.x = -v.x;
	if(x.y<-1.0f || +1.0f<x.y) v.y = -0.8f*v.y;
	if(x.z<-1.0f || +1.0f<x.z) v.z = -v.z;
	
	return 0.5f*v + 0.5f;
}
// -------------------------------------------------------------
// ˕Ԃ(ʒu)
// -------------------------------------------------------------
float4 ReflectXPS ( REFLECT_VS_OUTPUT In ) : COLOR0
{
	float4 x = 2.0f*tex2D( ParticleSamp, In.x )-1.0f;
	float4 v = 2.0f*tex2D( ParticleSamp, In.v )-1.0f;
	
	if(x.x<-1.0f) x.x = -1.0f; else
	if(+1.0f<x.x) x.x = +1.0f;	
	if(x.y<-1.0f) x.y = -1.0f; else
	if(+1.0f<x.y) x.y = +1.0f;	
	if(x.z<-1.0f) x.z = -1.0f; else
	if(+1.0f<x.z) x.z = +1.0f;	
	
	return 0.5f*x + 0.5f;
}

// -------------------------------------------------------------
// technique
// -------------------------------------------------------------
technique TShader
{
    pass P0// p[eBN̕`
    {
        // VF[_
        VertexShader = <DisplacementVS>;
        PixelShader  = <DisplacementPS>;
        // 萔
        VertexShaderConstantF[0]  = (mWVP);
        // Tv
        Sampler[0] = (DecaleSamp);
    }
    pass P1// p[eBN}bv̏
    {
        // VF[_
        VertexShader = compile vs_1_1 InitVS();
        PixelShader  = compile ps_1_1 InitPS();
    }
    pass P2// p[eBN̎ԔW
    {
        // Shader
        PixelShader  = compile ps_2_0 ParticlePS();
    }
    pass P3// ˕Ԃ (x)
    {
        // Shader
        PixelShader  = compile ps_2_0 ReflectVPS();
    }
    pass P4// ˕Ԃ (ʒu)
    {
        // Shader
        PixelShader  = compile ps_2_0 ReflectXPS();
    }
    
}
